\documentclass[12pt]{article}
 \usepackage[margin=1in]{geometry} 
\usepackage{amsmath,amsthm,amssymb,amsfonts}
\usepackage{graphicx}
\usepackage{subcaption}
\usepackage{float}
\usepackage{hyperref} 
 
\newcommand{\N}{\mathbb{N}}
\newcommand{\Z}{\mathbb{Z}}
 
\begin{document}

 
\title{Tutorial: creating setup.exe}
\author{Angel Ruy-Diaz Rojas}
\maketitle

\section{Introduction}
In this tutorial it will be shown either how to create a setup.exe file from scratch and how to update the current already created setup file. To start with this tutorial make sure that you have installed Visual Studio Installer Projects (follow the link to do so: \url{https://marketplace.visualstudio.com/items?itemName=UnniRavindranathan-MSFT.MicrosoftVisualStudio2013InstallerProjects} and that you have opened the SimuSCA solution in Visual Studio. On the Solution Explorer it should appear something like:

\begin{figure}[h]
	\centering
	\includegraphics[width=0.35\textwidth]{sol-exp-basic}
 	\caption{Solution Explorer with SimuSCA opened}
 	\label{sol-exp-basic}
\end{figure}

This tutorial is an adaptation of the video \url{https://www.youtube.com/watch?v=tiHBwAp_Kz4}


\section{Update the setup file}
For updating the setup file, there are to main cases:

\begin{itemize}
\item No file has been added to the folder \textit{bin} (in any of the folders inside it)
\item New files have been added to the folder \textit{bin} or new dependencies are used.
\end{itemize}

\subsection{First case}
The easiest way to update the setup.exe is doing a right click on the SetupSimusat project in the \textit{Solution Explorer} and clicking on Rebuild. This will regenerate the setup file and the new version of Simusat will be installable with it.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.7\textwidth]{rebuild}
 	\caption{How to rebuild}
 	\label{rebuild}
\end{figure}

It is also desirable to go to the top menu, Build

\subsection{Second case} \label{second case}
If the only change done to the bin folder is adding any file, you will have to add them manually to the SetupSimusat project. Open it, click on \textit{Application Folder} in the left column (File System Target Machine) and then go to the right column and right click inside the desired folder to click on Add (see figure \ref{add-file}) to add the file or folder desired.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.9\textwidth]{add-file}
 	\caption{Adding a file/folder}
 	\label{add-file}
\end{figure}

\textbf{Note:} As it is not possible to add complete folders, you will have to add the folders having the exact same name than those that are in the original \textit{bin} file. The ones that appear on the image where manually added. The \textit{.dll}  where added automatically by the wizard setup creator (see section \ref{sec: create setup}) 

\textbf{Note:} The folder \textit{Application Folder} in the left column is equivalent to the \textit{bin} folder. Every folder in bin should also appear here.

Once every file and folder has been added, rebuild the setup as it was shown in the first case.

If more dependencies are added to the software, I (the author of this tutorial at the date of 11th of september of 2019) do not know if just rebuilding is sufficient. If that is not the case, create a new setup from scratch.

\section{Create a setup file from scratch } \label{sec: create setup}
The procedure for creating the setup is the one  explained in the video mentioned in the introduction adding the folders and files necessaries as explained in the section \ref{second case}.

Being at the point that the Introduction sets, go to File -$>$ Add -$>$ New Project. There, click on Pther Projects Types -$>$ Visual Studio Installer -$>$ Setup Wizard. Select a name for the project and choose a folder for it (it is recommended to choose the Simusat folder to push it later on the Git. 

\begin{figure}[h]
	\centering
	\includegraphics[width=0.8\textwidth]{new-project}
 	\caption{Creating a new setup project}
 	\label{new-project}
\end{figure}

After that, click on Ok and follow the Wizard:

\begin{figure}[H]
	\centering
	\includegraphics[width=0.7\textwidth]{step1}
 	\caption{step 1}
 	\label{step1}
\end{figure}

\begin{figure}[H]
	\centering
	\includegraphics[width=0.7\textwidth]{step2}
 	\caption{step 2}
 	\label{step2}
\end{figure}

\begin{figure}[H]
	\centering
	\includegraphics[width=0.7\textwidth]{step3}
 	\caption{step 3}
 	\label{step3}
\end{figure}

After these steps, click on finish, the steps 4 and 5 are not interesting for us.

The next step is adding all the folders inside \textit{bin} as stated in \ref{second case}. Make sure to include the README.txt file. After that, do a right click on \textit{User's Desktop}, click on Create Shortcut and give it a name. That name will be the one that will appear to the user on the menus. Repeat the process with \textit{User's Program Menu}.

To add the icon that will be seen, add the file \textit{Simusat2011.ico} into \textit{Applciation Folder}. After that, go to the shortcuts created and: right click, Property Window, Icon, Browse, Application folder and select the .ico file. Click on ok.

Now, we are going to changes some properties of the project so that the program installed has the proper information like the author, name, etc. To do so, click on the setup project and press F4 to open the properties window. Once in it, change the following fields:

\begin{itemize}
\item Author: ISAE-SUPAERO
\item Manufacturer: ISAE-SUPAERO
\item Product Name: Simusat VXX
\item Title: Simusat Setup
\end{itemize}


Once you have it, go back to the Solution Explorer and right click on the setup project to click on build and generate the installer file. You will find it inside the project folder in debug or Release (depending on where were you in the moment of creating it).

\end{document}